"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var _1 = require("../");
var error_handler_1 = require("./error.handler");
exports.SENTRY_CONFIG = new core_1.InjectionToken('SENTRY_CONFIG');
var SentryConfig = (function () {
    function SentryConfig() {
        this.dsn = '';
    }
    return SentryConfig;
}());
exports.SentryConfig = SentryConfig;
var SentryService = (function () {
    function SentryService(config) {
        if (config) {
            this.dsn = config.dsn;
        }
    }
    SentryService = __decorate([
        core_1.Injectable(),
        __param(0, core_1.Optional()),
        __metadata("design:paramtypes", [SentryConfig])
    ], SentryService);
    return SentryService;
}());
exports.SentryService = SentryService;
var SentryModule = (function () {
    function SentryModule(config) {
        if (config && config.dsn) {
            _1.Sentry.init(config.dsn, null);
        }
        else {
            console.error('You need to provide a dsn on the forRoot method');
        }
    }
    SentryModule_1 = SentryModule;
    SentryModule.forRoot = function (config) {
        return {
            ngModule: SentryModule_1,
            providers: [
                { provide: SentryConfig, useValue: config },
                { provide: core_1.ErrorHandler, useClass: error_handler_1.SentryErrorHandler },
            ]
        };
    };
    SentryModule = SentryModule_1 = __decorate([
        core_1.NgModule({
            declarations: [],
            providers: [SentryConfig],
            exports: [],
            schemas: [core_1.NO_ERRORS_SCHEMA]
        }),
        __metadata("design:paramtypes", [SentryConfig])
    ], SentryModule);
    return SentryModule;
    var SentryModule_1;
}());
exports.SentryModule = SentryModule;
//# sourceMappingURL=app.module.js.map