"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var observable_1 = require("tns-core-modules/data/observable");
var Raven = require("raven-js");
var http = require("tns-core-modules/http");
var platform = require("tns-core-modules/platform");
var appversion = require("nativescript-appversion");
var Common = (function (_super) {
    __extends(Common, _super);
    function Common() {
        return _super.call(this) || this;
    }
    Common.urlencode = function (obj) {
        var pairs = [];
        for (var key in obj) {
            if ({}.hasOwnProperty.call(obj, key))
                pairs.push(encodeURIComponent(key) + '=' + encodeURIComponent(obj[key]));
        }
        return pairs.join('&');
    };
    Common._init = function (dsn, config) {
        var _this = this;
        Raven.config(dsn)
            .setTransport(function (options) {
            console.log('sending');
            http.request({
                url: options.url + '?' + _this.urlencode(options.auth),
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                    'Origin': 'nativescript://'
                },
                content: JSON.stringify(options.data)
            })
                .then(function (res) {
                if (res.statusCode !== 200) {
                    if (options.onError) {
                        options.onError(new Error('Unable to connect to raven status code: ' + res.statusCode));
                    }
                }
                else {
                    if (options.onSuccess) {
                        options.onSuccess();
                    }
                }
            }, function (e) {
                console.log('error');
                console.log(e);
                if (options.onError) {
                    options.onError(e);
                }
            });
        })
            .setDataCallback(function (data) {
            data.contexts = {
                device: {
                    family: platform.device.manufacturer,
                    model: platform.device.model,
                },
                os: {
                    name: platform.device.os,
                    version: platform.device.osVersion
                },
                runtime: {
                    name: 'nativescript',
                }
            };
            return data;
        })
            .setRelease(appversion.getVersionNameSync())
            .install();
    };
    Common._setUser = function (user) {
        Raven.setUserContext(user);
    };
    Common._setTags = function (tags) {
        Raven.setTagsContext(tags);
    };
    Common._setExtra = function (extra) {
        Raven.setExtraContext(extra);
    };
    Common._clearContext = function () {
        Raven.clearContext();
    };
    Common._captureMessage = function (message, options) {
        Raven.captureMessage(message, options);
    };
    Common._captureException = function (exception, options) {
        Raven.captureException(exception, options);
    };
    Common._captureBreadcrumb = function (breadcrumb) {
        Raven.captureBreadcrumb(breadcrumb);
    };
    return Common;
}(observable_1.Observable));
exports.Common = Common;
//# sourceMappingURL=sentry.common.js.map