"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var sentry_common_1 = require("./sentry.common");
var application = require("tns-core-modules/application");
var sentry_appdelegate_1 = require("./sentry.appdelegate");
var Sentry = (function (_super) {
    __extends(Sentry, _super);
    function Sentry() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Sentry.init = function (dsn) {
        this._init(dsn);
        try {
            SentryClient.sharedClient = SentryClient.alloc().initWithDsnDidFailWithError(dsn);
            application.ios.delegate = sentry_appdelegate_1.SentryAppDelegate;
        }
        catch (error) {
            console.log('[Sentry - iOS] Exeption on init: ', error);
        }
        application.on(application.uncaughtErrorEvent, function (args) {
            try {
                SentryJavaScriptBridgeHelper.parseJavaScriptStacktrace(args.ios);
            }
            catch (e) {
                console.log('[Sentry - iOS] Exeption on uncaughtErrorEvent: ', e);
            }
        });
    };
    Sentry.captureMessage = function (message, options) {
        this._captureMessage(message, options);
    };
    Sentry.captureException = function (exception, options) {
        this._captureException(exception, options);
    };
    Sentry.captureBreadcrumb = function (breadcrumb) {
        this._captureBreadcrumb(breadcrumb);
    };
    Sentry.setContextUser = function (user) {
        this._setUser(user);
        var userNative = SentryUser.alloc().init();
        userNative.email = user.email;
        userNative.username = user.username;
        SentryClient.sharedClient.user = userNative;
    };
    Sentry.setContextTags = function (tags) {
        this._setTags(tags);
        SentryClient.sharedClient.tags = tags;
    };
    Sentry.setContextExtra = function (extra) {
        this._setExtra(extra);
        SentryClient.sharedClient.extra = extra;
    };
    Sentry.clearContext = function () {
        this._clearContext();
        SentryClient.sharedClient.clearContext();
    };
    Sentry.onBeforeSend = function (callback) {
        SentryClient.sharedClient.beforeSerializeEvent = function (event) {
            console.log('vou enviar no ios');
            callback(event);
        };
    };
    return Sentry;
}(sentry_common_1.Common));
exports.Sentry = Sentry;
//# sourceMappingURL=sentry.ios.js.map